using System;
using System.ComponentModel.Design;
class Program
{
    static void Main()
    {

       int t = int.Parse(Console.ReadLine());
        string[] s = Console.ReadLine().Split();
        long n = long.Parse(s[0]);
        long k = long.Parse(s[1]);
        string[] s1 = Console.ReadLine().Split();
        long[] a = new long[n];
        for (int i = 0; i < n; i++)
        {
            a[i] = long.Parse(s1[i]);
        }

        if (k < a[1])
        {
                if (n == k)
                {
                    Console.WriteLine("DA");
                    for (int i = 0; i < n; i++) Console.Write(a[1] + " ");
                }
                else Console.WriteLine("NE");
        }
        else
        {


                if (n % 2 == Math.Abs(a[1] % 2))
                {
                    if (k == a[1])
                    {
                        Console.WriteLine("DA");
                        if (t == 1) for (int i = 0; i < n; i++) Console.Write(a[1] + " ");
                    }
                    else Console.WriteLine("NE");
                }
                else
                {
                    if (k == a[1] + 1)
                    {
                        Console.WriteLine("DA");
                        if (t == 1) for (int i = 0; i < n; i++) Console.Write(a[1] + " ");
                    }
                    else Console.WriteLine("NE");
                }
        }
        
        

          
        
    }
}